/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.KelompokUserDto;
import com.portofolio.service.KelompokUserService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/kelompokUser")
public class KelompokUserController extends LocaleController {
    @Lazy
	@Autowired
    private KelompokUserService kelompokUserService;
    
    
    @ApiOperation("Api Untuk Menyimpan KelompokUser")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody KelompokUserDto entity,HttpServletRequest request) {
        Map<String, Object> result = kelompokUserService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update KelompokUser")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdKelompokUser", required = true) Integer kdKelompokUser,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody KelompokUserDto entity, HttpServletRequest request) {
        Map<String, Object> result = kelompokUserService.update(entity,kdKelompokUser,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus KelompokUser Berdasarkan KdKelompokUser")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdKelompokUser", required = true) Integer kdKelompokUser,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = kelompokUserService.deleteById(kdKelompokUser, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua KelompokUser")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaKelompokUser") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaKelompokUser", required = false) String namaKelompokUser,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = kelompokUserService.grid(page, rows, sort, dir, namaKelompokUser,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan KelompokUser Berdasarkan kdKelompokUser")
    @GetMapping("/findByKdKelompokUser")
    public ResponseEntity<Map<String, Object>> findByKdKelompokUser(
    		@RequestParam(value = "kdKelompokUser", required = true) Integer kdKelompokUser, 
    		HttpServletRequest request) {
        Map<String, Object> result = kelompokUserService.findByKdKelompokUser(kdKelompokUser);
        return RestUtil.getJsonResponse(result);
    }


}
